{*
 * File: ......................... Main.pas
 * Autor: ........................ Max Artemev (Bert Raccoon),
 * Copyright: .................... (c) 2003 by Max Artemev, MC NTT (www.ntt.ru)
 * Desc:
 *   Main form unit
 *}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ImageHlp,
  tlhelp32, StdCtrls, Menus, ExtCtrls, ComCtrls, ToolWin, ImgList, Buttons, ShellAPi,
  OleListView, comobj, shlobj, activex, ActnList, TrayIcon, AppEvnts, sockschain, direct_addr, inifiles,
  xml_config, cfg, DebugInject, RemoteThreadInject, SuspendInject, HH, HH_funcs;



type
  TDataItem = record
     ProfileName: string[255];
     FullPath   : string[255];
     WorkDir    : string[255];
     ProgramParams: string[255];
     hIco       : HICON;
     IconIndex  : integer;
  end;
  PDataItem = ^TDataItem;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Newapplication1: TMenuItem;
    Deleteapplication1: TMenuItem;
    N1: TMenuItem;
    Settings1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    ControlBar1: TControlBar;
    lstProgram: TOleListView;
    IcoList: TImageList;
    View1: TMenuItem;
    LargeIcons1: TMenuItem;
    SmallIcons1: TMenuItem;
    List1: TMenuItem;
    Details1: TMenuItem;
    Modifyapplication1: TMenuItem;
    ActionList1: TActionList;
    NewAppCmd: TAction;
    ModifyAppCmd: TAction;
    DeleteAppCmd: TAction;
    RunAppCmd: TAction;
    DeleteAppCmd1: TMenuItem;
    TrayIcon1: TTrayIcon;
    ApplicationEvents1: TApplicationEvents;
    ExitAppCmd: TAction;
    PopupMenu1: TPopupMenu;
    Modify1: TMenuItem;
    Run1: TMenuItem;
    Deleteapplication2: TMenuItem;
    N4: TMenuItem;
    Newapplication2: TMenuItem;
    ToolBar1: TToolBar;
    tb1: TToolButton;
    tb3: TToolButton;
    tb2: TToolButton;
    tb4: TToolButton;
    PopupMnu: TPopupMenu;
    N3: TMenuItem;
    SHowmainwindow1: TMenuItem;
    CloseFreeCap1: TMenuItem;
    About2: TMenuItem;
    N5: TMenuItem;
    Settings2: TMenuItem;
    ImageList1: TImageList;
    HelpIndex1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Settings1Click(Sender: TObject);
    procedure Details1Click(Sender: TObject);
    procedure lstProgramSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormShow(Sender: TObject);
    procedure NewAppCmdExecute(Sender: TObject);
    procedure ModifyAppCmdExecute(Sender: TObject);
    procedure DeleteAppCmdExecute(Sender: TObject);
    procedure RunAppCmdExecute(Sender: TObject);
    procedure lstProgramKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure About1Click(Sender: TObject);
    procedure TrayIcon1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ApplicationEvents1Minimize(Sender: TObject);
    procedure Showmainwindow1Click(Sender: TObject);
    procedure CloseFreeCap1Click(Sender: TObject);
    procedure ExitAppCmdExecute(Sender: TObject);
    procedure Settings2Click(Sender: TObject);
    function ApplicationEvents1Help(Command: Word; Data: Integer;
      var CallHelp: Boolean): Boolean;
    procedure HelpIndex1Click(Sender: TObject);
    procedure DeleteApp();
    procedure NewApp();
    procedure FormDestroy(Sender: TObject);
    procedure lstProgramShellLinkCreate(Sender: TObject; var DestFileName, WorkDir, Args, IconFile, Desc: String);
    procedure lstProgramDragOver(Sender: TObject; DataObject: IDataObject;
      State: TShiftState; MousePt: TPoint; var Effect, Result: Integer);
    procedure lstProgramDrop(Sender: TObject; DataObject: IDataObject;
      State: TShiftState; MousePt: TPoint; var Effect, Result: Integer);
    procedure lstProgramResize(Sender: TObject);

  private
    procedure AddDataItem(ProfileName, Path, WorkDir, ProgramParams: string);
    procedure DelDataItem(Item: PDataItem);
    procedure UpdateEntry(Item: PDataItem; ProfileName, Path,
      WorkDir, ProgramParams: string);
    procedure LoadPrograms;
    procedure SavePrograms;
    procedure MenuClick(Sender: TObject);
    procedure LoadOldPrograms;
    procedure UpdateContextMenu;
    { Private declarations }
    procedure ResolveLinkInfo(LinkPath: string; var ProgramPath, ProgramWorkPath, ProgramInfo, ProgramParams: string);

  protected
    procedure MineRestore(var Msg: TMessage); message WM_MINERESTORE;
    procedure WMDropFiles(var Msg: TMessage); message WM_DROPFILES;
    procedure DefaultHandler(var Message); override;
  public

    { Public declarations }
  end;



var
  frmMain: TfrmMain;
  ini_file: string;
  WndList : TStringList;
   _pt: TPoint;
  mFile: string;
implementation

uses config, profile, about;

{$R *.DFM}




procedure TfrmMain.AddDataItem(ProfileName, Path, WorkDir, ProgramParams: string);
var
   Item      : TListItem;
   pData     : PDataItem;
   icoIndex  : word;
   ico       : TIcon;
   bmp       : TBitmap;
   progname  : string;
begin
     Item := lstProgram.Items.Add;

     GetMem(pData, SizeOf(TDataItem));
     Item.Data := pData;
     Item.Caption := ProfileName;
     pData^.ProfileName := ProfileName;

     icoIndex := 0;
     pData^.FullPath := Path;
     pData^.WorkDir := WorkDir;
     pData^.ProgramParams := ProgramParams;

     progname := ExtractFileName(Path);
     Delete(progname, pos(' ', progname), MaxInt);

     pData^.hIco := ExtractAssociatedIcon(hInstance, PChar(ExtractFilePath(Path) + progname), icoIndex);

     bmp := TBitmap.Create;
     bmp.Width := 32;
     bmp.Height := 32;

     ico := TIcon.Create;
     ico.Handle := pData^.hIco;

     bmp.Canvas.Draw(0, 0, ico);
     pData^.IconIndex := IcoList.AddMasked(bmp, bmp.Canvas.Pixels[0,0]);

     Item.ImageIndex := pData^.IconIndex;
     Item.SubItems.Add(Path);
     Item.SubItems.Add(WorkDir);
     ico.Free;
     bmp.Free;

     UpdateContextMenu();
end;


procedure TfrmMain.UpdateEntry(Item: PDataItem; ProfileName, Path, WorkDir, ProgramParams: string);
var
   lItem     : TListItem;
   icoIndex  : word;
   ico       : TIcon;
   i         : integer;
   hIco      : HICON;
begin
     lItem := nil;
     for i:=0 to lstProgram.Items.Count - 1 do
        if lstProgram.Items[i].Data = Item then
        begin
             lItem := lstProgram.Items[i];
             break;
        end;
     if lItem = nil then exit;


     Item^.ProfileName := ProfileName;
     Item^.FullPath := Path;
     Item^.WorkDir := WorkDir;
     Item^.ProfileName := ProfileName;
     Item^.ProgramParams := ProgramParams;

     icoIndex := 0;
     hIco := ExtractAssociatedIcon(hInstance, PChar(Path), icoIndex);

     ico := TIcon.Create;
     ico.Handle := hIco;
     Item^.hIco := hIco;

     IcoList.ReplaceIcon(Item^.IconIndex, ico);

     lItem.Caption := ProfileName;
     lItem.SubItems.Clear;
     lItem.SubItems.Add(Path);
     lItem.SubItems.Add(WorkDir);
     ico.Free;
     UpdateContextMenu();
end;


procedure TfrmMain.DelDataItem(Item: PDataItem);
begin
     FreeMem(Item);
end;



procedure TfrmMain.LoadOldPrograms();
var
   Sections: TStringList;
   i  : integer;
   Ini: TIniFile;
begin
     Sections  := TStringList.Create;
     Ini := TIniFile.Create('freecapp.ini');
     Ini.ReadSections(Sections);
     for i:=0 to Sections.Count - 1 do
        AddDataItem(Sections[i], ini.ReadString(Sections[i],'Path',''), ini.ReadString(Sections[i],'WorkDir',''), '');
     Ini.Free;
     Sections.Free;
end;


procedure TfrmMain.LoadPrograms();
var
   Sections: TStringList;
   i  : integer;
   Ini: TXMLConfig;
begin
     if isConfigExists('freecapp.ini') and (not isConfigExists('freecap.xml')) then
     begin
          LoadOldPrograms();
          exit;
     end;

     Sections  := TStringList.Create;
     Ini := TXMLConfig.Create('freecap.xml');

     frmMain.Width := Ini.ReadInteger(PART_MAIN, 'Main','Width', frmMain.Width);
     frmMain.Height := Ini.ReadInteger(PART_MAIN, 'Main','Height', frmMain.Height);
     frmMain.Left := Ini.ReadInteger(PART_MAIN, 'Main','Left', frmMain.Left);
     frmMain.Top := Ini.ReadInteger(PART_MAIN, 'Main','Top', frmMain.Top);

     Ini.ReadSections(PART_PROGRAMS, Sections);
     for i:=0 to Sections.Count - 1 do
        AddDataItem(Sections[i], ini.ReadString(PART_PROGRAMS, Sections[i],'Path',''), ini.ReadString(PART_PROGRAMS, Sections[i],'WorkDir','') , ini.ReadString(PART_PROGRAMS, Sections[i],'Params',''));
     Ini.Free;
     Sections.Free;
end;


procedure TfrmMain.SavePrograms();
var
   Sections: TStringList;
   i  : integer;
   Ini: TXMLConfig;
   Item: TDataItem;
begin
     Sections  := TStringList.Create;
     Ini := TXMLConfig.Create('freecap.xml');
     Ini.ReadSections(PART_PROGRAMS, Sections);
     for i:=0 to Sections.Count - 1 do
        Ini.EraseSection(PART_PROGRAMS, Sections[i]);
     Sections.Free;

     for i:=0 to lstProgram.Items.Count - 1 do
     begin
          Item := PDataItem(lstProgram.Items[i].Data)^;
          Ini.WriteString(PART_PROGRAMS, Item.ProfileName, 'Path', Item.FullPath);
          Ini.WriteString(PART_PROGRAMS, Item.ProfileName, 'WorkDir', Item.WorkDir);
          Ini.WriteString(PART_PROGRAMS, Item.ProfileName, 'Params', Item.ProgramParams);
     end;

     Ini.WriteInteger(PART_MAIN, 'Main', 'ViewStyle', Integer(lstProgram.ViewStyle));

     Ini.WriteInteger(PART_MAIN, 'Main','Width', frmMain.Width);
     Ini.WriteInteger(PART_MAIN, 'Main','Height', frmMain.Height);
     Ini.WriteInteger(PART_MAIN, 'Main','Left', frmMain.Left);
     Ini.WriteInteger(PART_MAIN, 'Main','Top', frmMain.Top);

     Ini.Free;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
var
   vs : integer;
begin
     mFile := ExtractFilePath(paramStr(0)) + 'freecap.chm';

     LoadPrograms();
     ReadConfig();

     WndList := TStringList.Create;


     vs := cfg.prog_view_style;

     if not (vs in [0..3]) then
       vs := 0;
     lstProgram.ViewStyle := TViewStyle(vs);
     lstProgram.Visible := True;
     lstProgram.Update;
     case vs of
       0: LargeIcons1.Checked := True;
       1: SmallIcons1.Checked := True;
       2: List1.Checked := True;
       3: Details1.Checked := True;
     end;
     sockschain.init;
     direct_addr.init;
     DragAcceptFiles(frmMain.Handle, True);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     SavePrograms();
end;

procedure TfrmMain.Settings1Click(Sender: TObject);
begin
     frmConfig.Show;
end;

procedure TfrmMain.Details1Click(Sender: TObject);
begin
     lstProgram.ViewStyle := TViewStyle((Sender as TComponent).Tag);
     (Sender as TMenuItem).Checked := True;
end;

procedure TfrmMain.lstProgramSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
     ModifyAppCmd.Enabled := Selected;
     DeleteAppCmd.Enabled := Selected;
     RunAppCmd.Enabled := Selected;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
     ModifyAppCmd.Enabled := (lstProgram.Selected <> nil);
     DeleteAppCmd.Enabled := (lstProgram.Selected <> nil);
     RunAppCmd.Enabled := (lstProgram.Selected <> nil);
end;

procedure TfrmMain.NewApp();
begin
     frmProfile.ProfileName := '';
     frmProfile.WorkingDir := '';
     frmProfile.FullPath := '';
     if frmProfile.ShowModal = mrOk then
       AddDataItem(frmProfile.ProfileName, frmProfile.FullPath, frmProfile.WorkingDir, frmProfile.ProgramParams);
end;

procedure TfrmMain.NewAppCmdExecute(Sender: TObject);
begin
     NewApp();
end;

procedure TfrmMain.ModifyAppCmdExecute(Sender: TObject);
var
   Item: TDataItem;
begin
     if lstProgram.Selected <> nil then
     begin
          Item := PDataItem(lstProgram.Selected.Data)^;
          frmProfile.ProfileName := Item.ProfileName;
          frmProfile.FullPath := Item.FullPath;
          frmProfile.WorkingDir := Item.WorkDir;
          frmProfile.ProgramParams := Item.ProgramParams;

          if frmProfile.ShowModal = mrOk then
          begin
               UpdateEntry(lstProgram.Selected.Data, frmProfile.ProfileName, frmProfile.FullPath, frmProfile.WorkingDir, frmProfile.ProgramParams);
               SavePrograms();
          end;
     end;
end;

procedure TfrmMain.DeleteApp();
var
   ini: TXMLConfig;
begin
     if lstProgram.Selected <> nil then
     begin
          if (MessageDlg(Format('Are you sure you want to delete %s?',[lstProgram.Selected.Caption]),mtConfirmation, [mbYes, mbNo], 0)) = mrYes then
          begin
               Ini := TXMLConfig.Create('freecap.xml');
               Ini.EraseSection(PART_PROGRAMS, lstProgram.Selected.Caption);
               Ini.Free;

               DelDataItem(lstProgram.Selected.Data);
               lstProgram.Items.Delete(lstProgram.Items.IndexOf(lstProgram.Selected));
               UpdateContextMenu();
          end;
     end;
end;


procedure TfrmMain.DeleteAppCmdExecute(Sender: TObject);
begin
     DeleteApp();
end;

procedure TfrmMain.RunAppCmdExecute(Sender: TObject);
var
   injector1: TSuspendInjector;
   injector2: TDebugInjector;
   injector3: TRemoteInjector;
   filename, workdir, params : string;
begin
     if lstProgram.Selected <> nil then
     begin
          filename := PDataItem(lstProgram.Selected.Data)^.FullPath;
          workdir := PDataItem(lstProgram.Selected.Data)^.WorkDir;
          params := PDataItem(lstProgram.Selected.Data)^.ProgramParams;
     {$DEFINE USE_SUSPEND_INJECT}
     {*
      *  Suspend-thread injection is an unvirsal solution. Works both on Win9x and WinNT platforms. (tested)
      *  Other methods, provided just for information how it can implement in another way
      *}
     {$IFDEF USE_SUSPEND_INJECT}
          injector1 := TSuspendInjector.Create;
          injector1.LoadProcess(filename, params, workdir);
          injector1.SetDLLToInject(ExtractFilePath(Application.Exename) + 'inject.dll');
          injector1.Run();
     {$ENDIF}

     {$IFDEF USE_DEBUG_INJECT}
     {* This method has it owns minuses. First: debugger process *CANNOT* detach from debugee program
      * And you need to place ProcessMessages() function into the Run() class method
      *}
          injector2 := TDebugInjector.Create;
          injector2.LoadProcess(filename, workdir);
          injector2.SetDLLToInject(ExtractFilePath(Application.Exename) + '\inject.dll');
          injector2.Run();
     {$ENDIF}

     {$IFDEF USE_REMOTE_THREAD_INJECT}
     {* This method is easy to implement, but it works only under WinNT.
      *}
           injector3 := TRemoteInjector.Create(filename, workdir, ExtractFilePath(Application.Exename) + '\inject.dll');
           injector3.Run();
     {$ENDIF}


     {* Other methods such as `registry injection` or static spy library linking not listed here.
      * I already weary without it.
      *}
     end;
end;

procedure TfrmMain.lstProgramKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key = VK_RETURN then
        RunAppCmd.Execute;
     if Key = VK_DELETE then
       DeleteApp();
     if Key = VK_INSERT then
       NewApp();
end;

procedure TfrmMain.About1Click(Sender: TObject);
begin
{     WndList.Clear;
     SendMessage(HWND_BROADCAST, WM_PLEASE_REPLY_WHO_ALIVE, frmMain.Handle, 0);
     ShowMessage(WndList.Text);}
     frmAbout.Show;
end;

procedure TfrmMain.TrayIcon1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if (Sender is TTrayIcon) and (Button = mbRight) then
     begin
          SetForegroundWindow(Handle);
          PopupMnu.Popup(X, Y);
     end;
end;

procedure TfrmMain.ApplicationEvents1Minimize(Sender: TObject);
begin
     if cfg.prog_min_tray then
     begin
          ShowWindow(Application.Handle, SW_HIDE);
          ShowWindow(frmMain.Handle, SW_HIDE);
     end;
end;

procedure TfrmMain.Showmainwindow1Click(Sender: TObject);
begin
     if cfg.prog_min_tray or cfg.prog_run_tray then
     begin
          ShowWindow(Application.Handle, SW_RESTORE);
          ShowWindow(Application.Handle, SW_SHOW);
          ShowWindow(frmMain.Handle, SW_RESTORE);
          ShowWindow(frmMain.Handle, SW_SHOW);
          frmMain.Visible := True;
          SetForegroundWindow(Handle);
     end;
end;

procedure TfrmMain.MenuClick(Sender: TObject);
var
   Item: TMenuItem;
begin
     Item := TMenuItem(Sender);
     lstProgram.Selected := lstProgram.Items[-Item.Tag];
     RunAppCmd.Execute;
end;

procedure TfrmMain.CloseFreeCap1Click(Sender: TObject);
begin
     ExitAppCmd.Execute;
end;

procedure TfrmMain.ExitAppCmdExecute(Sender: TObject);
begin
     Close;
end;

procedure TfrmMain.Settings2Click(Sender: TObject);
begin
     if cfg.prog_min_tray or cfg.prog_run_tray then
     begin
          ShowWindow(frmConfig.Handle, SW_RESTORE);
          ShowWindow(frmConfig.Handle, SW_SHOW);
          frmConfig.Visible := True;
     end;
end;


procedure TfrmMain.UpdateContextMenu();
var
   Item: TMenuItem;
   i: integer;
   Bmp: TBitmap;
   AItems: array of TMenuItem;
   Index: integer;
begin
     for i:=0 to PopupMnu.Items.Count - 1 do
     begin
          if PopupMnu.Items[i].Tag = 1 then
          begin
               Index := Length(AItems);
               SetLength(AItems, Succ(Index));
               AItems[Index] := PopupMnu.Items[i];
          end;
     end;

     for i:=PopupMnu.Items.Count - 1 downto 0 do
       PopupMnu.Items.Delete(i);

     for i:=0 to lstProgram.Items.Count - 1 do
     begin
          Bmp := TBitmap.Create;
          Bmp.Width := 32;
          Bmp.Height := 32;

               Item := TMenuItem.Create(Self);
               Item.Caption := lstProgram.Items[i].Caption;
               IcoList.GetBitmap(lstProgram.Items[i].ImageIndex, Bmp);
               Bmp.TransparentColor := Bmp.Canvas.pixels[0,0];

               Item.Bitmap.Assign(Bmp);
               Item.Bitmap.Width := 16;
               Item.Bitmap.Height := 16;
               Item.OnClick := MenuClick;
               Item.Tag := -i;
               Item.Bitmap.Canvas.StretchDraw(Rect(0,0,16,16), Bmp);

               PopupMnu.Items.Add(Item);

               Bmp.Free;
          end;
          PopupMnu.Items.Add(AItems);
end;

procedure TfrmMain.MineRestore(var Msg: TMessage);
begin
     if (Msg.Msg = WM_MINERESTORE) then
     begin
          Application.ShowMainForm := True;
          ShowWindow(Application.Handle, SW_RESTORE);
          ShowWindow(Application.Handle, SW_SHOW);
          ShowWindow(frmMain.Handle, SW_RESTORE);
          ShowWindow(frmMain.Handle, SW_SHOW);
          frmMain.Visible := True;
          SetForegroundWindow(Handle);
     end;
end;


procedure TfrmMain.WMDropFiles(var Msg: TMessage);
var
   i, Amount, Size: integer;
   Filename: PChar;
   S, path, path_work, prog_info, prog_params : string;
begin
  inherited;
  Filename := nil;

  Amount := DragQueryFile(Msg.WParam, $FFFFFFFF, Filename, 255);
  for i := 0 to (Amount - 1) do
  begin
       Size := DragQueryFile(Msg.WParam, i , nil, 0) + 1;
       Filename := StrAlloc(size);

       DragQueryFile(Msg.WParam,i , Filename, Size);
       s := Extractfileext(Filename);
       if s = '.lnk' then
       begin
            ResolveLinkInfo(Filename, path, path_work, prog_info, prog_params);
            AddDataItem(GetProgramName(path), path, path_work, prog_params);
       end
       else
       begin
            s := StrPas(Filename);
            AddDataItem(GetProgramName(s), ExtractFilePath(s), ExtractFilePath(s), '');
       end;

       StrDispose(Filename);
  end;
  DragFinish(Msg.WParam);
end;


procedure TfrmMain.ResolveLinkInfo(LinkPath: string; var ProgramPath, ProgramWorkPath, ProgramInfo, ProgramParams: string);
Var
   Desc : Array[0..MAX_PATH] of Char;
   IU   : IUnknown;
   SL   : IShellLink;
   PF   : IPersistFile;
   HRES : HRESULT;
   FD   : TWin32FindData;
begin
     CoInitialize(nil);
     IU := CreateComObject(CLSID_ShellLink);
     SL := IU as IShellLink;
     PF := SL as IPersistFile;

     PF.Load(PWideChar(WideString(LinkPath)), STGM_READ);
     SL.Resolve(Handle, SLR_ANY_MATCH);
     SL.GetPath(Desc, MAX_PATH, FD, SLGP_UNCPRIORITY);
     ProgramPath := StrPas(Desc);


     SL.GetDescription(Desc, MAX_PATH);
     ProgramInfo := StrPas(Desc);

     SL.GetWorkingDirectory(Desc, MAX_PATH);
     ProgramWorkPath := StrPas(Desc);

     SL.GetArguments(Desc, MAX_PATH);
     ProgramParams := StrPas(Desc);

end;


procedure TfrmMain.DefaultHandler(var Message);
var
   Buf: array[0..1023] of Char;
begin
     inherited DefaultHandler(Message);
     with TMessage(Message) do
     begin
          if (Msg = WM_I_AM_ALIVE) and (WParam <> 0) then
          begin
               WndList.Add(Format('%u',[WParam]));
          end;
     end;
end;


function HH_ShowPopupHelp2(resID: integer; XYPos: TPoint): HWND;
var
   hhpopup: THHPopup;
begin
     with hhpopup do
     begin
          cbStruct := SizeOf(THHPopup);
          hinst := 0;
          idString := resID;
          pszText := nil;
          pt := XYPos;
          clrForeground := COLORREF(-1);
          clrBackground := COLORREF(-1);
          rcMargins := Rect(-1, -1, -1, -1);
          pszFont := '';
     end;

     if resID < 3000 then
       result := HtmlHelp(0, @(mFile + '::/popuphelp.txt')[1], HH_DISPLAY_TEXT_POPUP, DWORD(@hhpopup))
     else
       result := HtmlHelp(0, @mFile[1], HH_HELP_CONTEXT, resID);
end;


function TfrmMain.ApplicationEvents1Help(Command: Word; Data: Integer;
  var CallHelp: Boolean): Boolean;
begin
     CallHelp := False;
     case Command of
         HELP_CONTEXT: HtmlHelp(0, @mFile[1], HH_HELP_CONTEXT, Data);
         HELP_SETPOPUP_POS: _pt := SmallPointToPoint(TSmallPoint(Data));
         HELP_CONTEXTPOPUP: HH_ShowPopupHelp2(Data, _pt);
     else
         CallHelp := True;
     end;

     result := True;
end;

procedure TfrmMain.HelpIndex1Click(Sender: TObject);
begin
     HtmlHelp(0, @mFile[1], HH_HELP_CONTEXT, 3020);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var
   i: integer;
begin
     for i:= 0 to lstProgram.Items.Count - 1 do
        DelDataItem(lstProgram.Items[i].Data);
     lstProgram.Items.Clear;
end;

procedure TfrmMain.lstProgramShellLinkCreate(Sender: TObject;
  var DestFileName, WorkDir, Args, IconFile, Desc: String);
var
   destPath: string;
   Item: TDataItem;
begin
     if lstProgram.Selected <> nil then
     begin
          Item := PDataItem(lstProgram.Selected.Data)^;
          destPath := ExtractFilePath(Application.Exename);
          DestFileName := destPath + 'freecapCon.exe';
          WorkDir := Item.WorkDir;
          Args := '-u "' + destPath + 'inject.dll" "' + Item.FullPath + '" ' + Item.ProgramParams;
          IconFile := Item.FullPath;
          Desc := Item.ProfileName + ' via FreeCap';
     end;
end;

procedure TfrmMain.lstProgramDragOver(Sender: TObject;
  DataObject: IDataObject; State: TShiftState; MousePt: TPoint; var Effect,
  Result: Integer);
begin
     Effect := DROPEFFECT_COPY or DROPEFFECT_LINK;
end;

procedure TfrmMain.lstProgramDrop(Sender: TObject; DataObject: IDataObject;
  State: TShiftState; MousePt: TPoint; var Effect, Result: Integer);
var
  Medium : TSTGMedium;
  Format : TFormatETC;
  NumFiles: Integer;
  i : Integer;
  rslt : Integer;
  DropInfo : TDragDropInfo;
  szFilename : array [0..MAX_PATH] of char;
  InClient : Boolean;
  DropPoint : TPoint;

  Size: integer;
  Filename: PChar;
  S, path, path_work, prog_info, prog_params : string;
begin
     DataObject._AddRef;

     Format.cfFormat := CF_HDROP;
     Format.ptd      := nil;
     Format.dwAspect := DVASPECT_CONTENT;
     Format.lindex   := -1;
     Format.tymed    := TYMED_HGLOBAL;

     rslt := DataObject.GetData (Format, Medium);

     // If successful -- do like an 'deprecated' style drag-drop
     if (rslt = S_OK) then
     begin
          // Getting files count
          NumFiles := DragQueryFile (Medium.hGlobal, $FFFFFFFF, nil, 0);

          InClient := DragQueryPoint(Medium.hGlobal, DropPoint);

          // Create the TDragDropInfo object
          DropInfo := TDragDropInfo.Create(DropPoint, InClient);

          for i := 0 to NumFiles - 1 do
          begin
               Size := DragQueryFile(Medium.hGlobal, i , nil, 0) + 1;
               Filename := StrAlloc(size);
               DragQueryFile(Medium.hGlobal,i , Filename, Size);
               s := Extractfileext(Filename);
               if s = '.lnk' then
               begin
                    ResolveLinkInfo(Filename, path, path_work, prog_info, prog_params);
                    if path_work = '' then
                       path_work := ExtractFilePath(path);
                    if pos('freecapCon.exe', Filename) = 0 then
                      AddDataItem(GetProgramName(path), path, path_work, prog_params);
               end
               else
               begin
                    s := StrPas(Filename);
                    if pos('freecapCon.exe', Filename) = 0 then
                      AddDataItem(GetProgramName(s), ExtractFilePath(s), ExtractFilePath(s), '');
               end;
               StrDispose(Filename);
          end;

          DropInfo.Free;
     end;
     if (Medium.unkForRelease = nil) then
       ReleaseStgMedium (Medium);

     DataObject._Release;
     Effect := DROPEFFECT_COPY;
     result := S_OK;
end;

procedure TfrmMain.lstProgramResize(Sender: TObject);
begin
     lstProgram.Repaint;
end;

end.
