unit config;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, registry, sockschain, direct_addr, CheckLst, HH, pinger,
  Menus, ImgList, plugin_disp, plugin;

type
  TfrmConfig = class(TForm)
    PageControl1: TPageControl;
    tabDefault: TTabSheet;
    tabLog: TTabSheet;
    Image1: TImage;
    Label1: TLabel;
    btnOK: TButton;
    btnCancel: TButton;
    GroupBox3: TGroupBox;
    checkLog: TCheckBox;
    editLogFile: TEdit;
    checkINJ: TCheckBox;
    checkCONN: TCheckBox;
    checkSOCKS: TCheckBox;
    checkWARN: TCheckBox;
    checkTraffic: TCheckBox;
    Label6: TLabel;
    Image2: TImage;
    Label7: TLabel;
    tabProgram: TTabSheet;
    Image3: TImage;
    Label8: TLabel;
    tabDirect: TTabSheet;
    Image4: TImage;
    Label11: TLabel;
    GroupBox7: TGroupBox;
    Button8: TButton;
    Button9: TButton;
    lstDirect: TListBox;
    GroupBox8: TGroupBox;
    checkOne: TCheckBox;
    checkRunAtStartup: TCheckBox;
    checkRunTray: TCheckBox;
    checkMinTray: TCheckBox;
    checkCaption: TCheckBox;
    DNSGroup: TRadioGroup;
    btnHelp: TButton;
    tabChain: TTabSheet;
    GroupBox6: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    labUSERID: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    editLogin: TEdit;
    editPass: TEdit;
    Radio1: TRadioButton;
    checkAuth: TCheckBox;
    Radio2: TRadioButton;
    editUserID: TEdit;
    Radio3: TRadioButton;
    checkHttpAuth: TCheckBox;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    editHttpUser: TEdit;
    editHttpPass: TEdit;
    editSocksServ: TEdit;
    editSocksPort: TEdit;
    lvProxy: TListView;
    PopupMenu1: TPopupMenu;
    Pingselectedproxy1: TMenuItem;
    Checkselectedproxy1: TMenuItem;
    Moveup1: TMenuItem;
    Movedown1: TMenuItem;
    N1: TMenuItem;
    Addnew1: TMenuItem;
    Edit1: TMenuItem;
    Deleteselected1: TMenuItem;
    N2: TMenuItem;
    btnProxyAdd: TButton;
    btnProxyDel: TButton;
    btnUp: TButton;
    btnDown: TButton;
    tabPlugins: TTabSheet;
    lstPlugins: TListBox;
    Button1: TButton;
    Image5: TImage;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    plugName: TEdit;
    plugAuthor: TEdit;
    memoDescr: TMemo;
    Label15: TLabel;
    GroupBox5: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    lstDirectPorts: TListBox;
    checkWarns: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure checkLogClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
    procedure btnProxyAddClick(Sender: TObject);
    procedure Pingselectedproxy1Click(Sender: TObject);
    procedure Checkselectedproxy1Click(Sender: TObject);
    procedure lvProxyColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvProxyCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure lvProxyKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1Click(Sender: TObject);
    procedure Moveup1Click(Sender: TObject);
    procedure Movedown1Click(Sender: TObject);
    procedure Radio1Click(Sender: TObject);
    procedure Radio2Click(Sender: TObject);
    procedure Radio3Click(Sender: TObject);
    procedure checkAuthClick(Sender: TObject);
    procedure checkHttpAuthClick(Sender: TObject);
    procedure tabDefaultShow(Sender: TObject);
    procedure btnProxyDelClick(Sender: TObject);
    procedure tabPluginsShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    procedure SetLogEnabled(Value: Boolean);
    procedure LoadCfg;
    procedure SaveCfg;
    procedure AddToList(ChainItem: TSocksChainItem);
    procedure CheckHandler(Sender: TObject);
    procedure PingHandler(Sender: TObject);
    procedure TerminateCheck();
    procedure MoveProxy(ItemF, ItemT: Word);
    procedure MoveProxyUp();
    procedure MoveProxyDown();
    procedure DeleteProxies();
    procedure SetSocksVer(Ver: integer);
    procedure SetSocks5Auth(Value: boolean);
    procedure SetHttpAuth(Value: boolean);
    procedure UpdateDefaultProxy();

    { Private declarations }
  public
      DefaultItem: TSocksChainItem;

    { Public declarations }
  end;

  TPluginObject = class
  public
    PlugInfo : TPluginInfo;
  end;

var
  frmConfig: TfrmConfig;
  ColumnToSort: integer;

implementation
uses cfg, Main, common, newProxy;

{$R *.DFM}

function GetProxy(index: integer): TSocksChainItem;
begin
     result := SocksChains.Items[index];
end;

procedure RunOnStartup(WindowTitle, CommandLn: String; MustDelete: Boolean);
var
   RegIniFile  : TRegIniFile;
begin
     RegIniFile := TRegIniFile.Create('');
     with RegIniFile do
     begin
          RootKey := HKEY_CURRENT_USER;
          if not MustDelete then
             RegIniFile.WriteString('Software\Microsoft\Windows\CurrentVersion\Run'#0, WindowTitle, CommandLn)
          else
             RegIniFile.DeleteKey('Software\Microsoft\Windows\CurrentVersion\Run'#0, WindowTitle);
          Free;
     end;
end;


procedure TfrmConfig.SetSocks5Auth(Value: boolean);
begin
     if Value then
     begin
          editLogin.Color := clWindow;
          editPass.Color := clWindow;
     end
     else
     begin
          editLogin.Color := clInactiveBorder;
          editPass.Color := clInactiveBorder;
     end;

     editLogin.Enabled := Value;
     editPass.Enabled := Value;
end;

procedure TfrmConfig.SetHttpAuth(Value: boolean);
begin
     if Value then
     begin
          editHttpUser.Color := clWindow;
          editHttpPass.Color := clWindow;
     end
     else
     begin
          editHttpUser.Color := clInactiveBorder;
          editHttpPass.Color := clInactiveBorder;
     end;

     editHttpUser.Enabled := Value;
     editHttpPass.Enabled := Value;
end;


procedure TfrmConfig.SetSocksVer(Ver: integer);
begin
     editUserid.Color := clInactiveBorder;
     editLogin.Color := clInactiveBorder;
     editPass.Color := clInactiveBorder;
     checkAuth.Enabled := False;
     labUSERID.Enabled := False;
     editUserid.Enabled := False;
     checkAuth.Enabled := False;

     checkHttpAuth.Enabled := False;
     editHttpUser.Color := clInactiveBorder;
     editHttpPass.Color := clInactiveBorder;

     SetSocks5Auth(False);
     SetHttpAuth(False);


     radio1.Checked := (Ver = 4);
     radio2.Checked := (Ver = 5);
     radio3.Checked := (Ver = 1);

     if Ver = 5 then
     begin
          editUserid.Color := clInactiveBorder;
          editLogin.Color := clWindow;
          editPass.Color := clWindow;
          checkAuth.Enabled := True;

          if (DefaultItem <> nil) then
            checkAuth.Checked := DefaultItem.Auth
          else
            checkAuth.Checked := False;

          SetSocks5Auth(checkAuth.Checked);
     end
     else if Ver = 4 then
     begin
          editUserid.Color := clWindow;
          labUSERID.Enabled := True;
          editUserid.Enabled := True;
     end
     else if Ver = 1 then
     begin
          editHttpUser.Color := clInactiveBorder;
          editHttpPass.Color := clInactiveBorder;
          checkHttpAuth.Enabled := True;

          if (DefaultItem <> nil) then
            checkHttpAuth.Checked := DefaultItem.HTTP_Auth
          else
            checkHttpAuth.Checked := False;

          SetHttpAuth(checkAuth.Checked)
     end;
end;



procedure TfrmConfig.SetLogEnabled(Value: Boolean);
begin
     editLogFile.Enabled := Value;
     if Value then
       editLogFile.Color := clWindow
     else
       editLogFile.Color := clInactiveBorder;

     Label6.Enabled := Value;
     checkINJ.Enabled := Value;
     checkCONN.Enabled := Value;
     checkSOCKS.Enabled := Value;
     checkWARN.Enabled := Value;
     checkTraffic.Enabled := Value;
end;

procedure TfrmConfig.AddToList(ChainItem: TSocksChainItem);
var
   Item: TListItem;
begin
     Item := lvProxy.Items.Add();
     Item.Data := ChainItem;
     Item.Caption := ChainItem.Server + ':' + IntToStr(ChainItem.Port);
     Item.Checked := ChainItem.inUse;
     Item.SubItems.Add(ChainItem.Protocol);
     Item.SubItems.Add(ChainItem.Anon);
     Item.SubItems.Add('9999');
     Item.SubItems.Add('');
     ChainItem.Data := Item;
     ChainItem.OnCheckDone := CheckHandler;
     ChainItem.OnPingDone := PingHandler;
     Item.ImageIndex := -1;
end;


procedure TfrmConfig.LoadCfg();
var
   i: integer;
begin
     ReadConfig();
     SocksChains.LoadFromIni;
     DirectAddr.Load;
     lstDirect.Items.Clear;
     lvProxy.Items.Clear;

     for i := 0 to SocksChains.Count - 1 do
     begin
//          lstSocks.Items.Add(SocksChains[i].Server);
//          lstSocks.Checked[lstSocks.Items.Count - 1] := SocksChains[i].inUse;
          AddToList(SocksChains[i]);
     end;

     for i := 0 to DirectAddr.AddrCount - 1 do
     begin
          lstDirect.Items.Add(DirectAddr.Addr[i]);
     end;

     for i := 0 to DirectAddr.PortCount - 1 do
     begin
          lstDirectPorts.Items.Add(DirectAddr.Port[i]);
     end;

     checkLog.Checked  := cfg.socks_log;
     SetLogEnabled(checkLog.Checked);

     editLogFile.Text := cfg.socks_log_file;

     checkINJ.Checked := (cfg.socks_log_level and LOG_LEVEL_INJ) > 0;
     checkCONN.Checked := (cfg.socks_log_level and LOG_LEVEL_CONN) > 0;
     checkSOCKS.Checked := (cfg.socks_log_level and LOG_LEVEL_SOCKS) > 0;
     checkWARN.Checked := (cfg.socks_log_level and LOG_LEVEL_WARN) > 0;
     checkTraffic.Checked := cfg.socks_log_traffic;

     checkOne.Checked := cfg.prog_one_instance;
     checkRunAtStartup.Checked := cfg.prog_sys_startup;
     checkRunTray.Checked := cfg.prog_run_tray;
     checkMinTray.Checked := cfg.prog_min_tray;

     DNSGroup.ItemIndex := cfg.prog_resolve_dns;

     checkCaption.Checked := cfg.prog_add_caption_text;

     checkWarns.Checked := prog_show_messages;

     frmMain.TrayIcon1.Enabled := cfg.prog_min_tray or cfg.prog_run_tray;
     RunOnStartup('FreeSOCKS Cap',Application.ExeName, not cfg.prog_sys_startup);
end;


procedure TfrmConfig.SaveCfg();
begin
     cfg.socks_log := checkLog.Checked;
     cfg.socks_log_file := editLogFile.Text;

     cfg.socks_log_level := 0;
     if checkINJ.Checked then
       cfg.socks_log_level := cfg.socks_log_level or LOG_LEVEL_INJ;

     if checkCONN.Checked then
       cfg.socks_log_level := cfg.socks_log_level or LOG_LEVEL_CONN;

     if checkSOCKS.Checked then
       cfg.socks_log_level := cfg.socks_log_level or LOG_LEVEL_SOCKS;

     if checkWARN.Checked then
       cfg.socks_log_level := cfg.socks_log_level or LOG_LEVEL_WARN;

     cfg.socks_log_traffic := checkTraffic.Checked;

     cfg.prog_one_instance := checkOne.Checked;
     cfg.prog_sys_startup := checkRunAtStartup.Checked;
     cfg.prog_run_tray := checkRunTray.Checked;

     cfg.prog_min_tray := checkMinTray.Checked;
     cfg.prog_add_caption_text := checkCaption.Checked;

     prog_show_messages := checkWarns.Checked;

     try
        cfg.prog_resolve_dns := DNSGroup.ItemIndex;
     except
     end;

     frmMain.TrayIcon1.Enabled := cfg.prog_min_tray or cfg.prog_run_tray;
     RunOnStartup('FreeSOCKS Cap',Application.ExeName, not cfg.prog_sys_startup);


     cfg.SaveConfig();
     SocksChains.SaveToIni;
     DirectAddr.Save;
end;


procedure TfrmConfig.FormCreate(Sender: TObject);
begin
     LoadCfg;
end;


procedure TfrmConfig.checkLogClick(Sender: TObject);
begin
     SetLogEnabled(checkLog.Checked);
end;

procedure TfrmConfig.btnCancelClick(Sender: TObject);
begin
     TerminateCheck();
     LoadCfg;
     close;
end;

procedure TfrmConfig.btnOKClick(Sender: TObject);
var
   i: integer;
begin
     UpdateDefaultProxy();
     for i := 0 to lvProxy.Items.Count - 1 do
        GetProxy(i).inUse := lvProxy.Items[i].Checked;

     SaveCfg;
     close;
end;


procedure TfrmConfig.FormDestroy(Sender: TObject);
begin
     SaveCfg;
end;

procedure TfrmConfig.UpdateDefaultProxy();
var
   ver: integer;
   LVItem: TListItem;
begin
     if PageControl1.ActivePageIndex <> 0 then exit;

     ver := 0;
     if radio1.Checked then
       ver := 4;
     if radio2.Checked then
       ver := 5;
     if radio3.Checked then
       ver := 1;

     if editSocksServ.Text <> '' then
     begin
          if DefaultItem = nil then
          begin
               DefaultItem := SocksChains.AddSocks(editSocksServ.Text,
                          StrToIntDef(editSocksPort.Text, 1080),
                          ver,
                          editLogin.Text,
                          editPass.Text,
                          editUserId.Text,
                          checkAuth.Checked,
                          editHttpUser.Text,
                          editHttpUser.Text,
                          checkHttpAuth.Checked);
               DefaultItem.inUse := True;                          
               AddToList(DefaultItem);
          end
          else
          begin
               DefaultItem.Auth := checkAuth.Checked;
               DefaultItem.Server := editSocksServ.Text;
               DefaultItem.Port := StrToIntDef(editSocksPort.Text, 1080);
               DefaultItem.Login := editLogin.Text;
               DefaultItem.Password := editPass.Text;
               DefaultItem.ident := editUserId.Text;
               DefaultItem.HTTP_User := editHttpUser.Text;
               DefaultItem.HTTP_Pass := editHttpPass.Text;
               DefaultItem.HTTP_Auth := checkHttpAuth.Checked;
               DefaultItem.Version := ver;

          end;
          LVItem := lvProxy.FindData(0, DefaultItem, True, False);
          LVItem.Caption := DefaultItem.Server;
          LVItem.SubItems[0] := DefaultItem.Protocol;
          LVItem.SubItems[1] := DefaultItem.Anon;
     end;
end;

procedure TfrmConfig.Button8Click(Sender: TObject);
var
   s: string;
begin
     s := InputBox('New IP address', 'Enter new IP address', '');
     if (s <> '') then
     begin
          if (not IsCorrectIP(s)) then
          begin
               ShowMessage('Invalid IP');
               exit;
          end;
          DirectAddr.Add(s);
          lstDirect.Items.Add(s);
     end;
end;

procedure TfrmConfig.Button9Click(Sender: TObject);
var
   i: integer;
begin
     if lstDirect.ItemIndex <> -1 then
     begin
          i := lstDirect.ItemIndex;
          DirectAddr.Del(lstDirect.Items[i]);
          lstDirect.Items.Delete(i);

          if i >= lstDirect.Items.Count then
            lstDirect.ItemIndex := lstDirect.Items.Count - 1
          else
            lstDirect.ItemIndex := i;

     end;
end;

procedure TfrmConfig.btnHelpClick(Sender: TObject);
begin
     Application.HelpContext(PageControl1.ActivePage.HelpContext);
end;

procedure TfrmConfig.btnProxyAddClick(Sender: TObject);
begin
     frmNewProxy.ProxyItem := nil;
     if frmNewProxy.ShowModal() = mrOK then
     begin
          frmNewProxy.ProxyItem.inUse := True;
          AddToList(frmNewProxy.ProxyItem);
     end;
end;

procedure TfrmConfig.Pingselectedproxy1Click(Sender: TObject);
var
   i: integer;
   Item: TListItem;
begin
     for i:=0 to lvProxy.Items.Count - 1 do
     begin
          Item := lvProxy.Items[i];
          if (Item.Selected) then
             GetProxy(i).Ping;
     end;
end;

procedure TfrmConfig.Checkselectedproxy1Click(Sender: TObject);
var
   i: integer;
   Item: TListItem;
   ProxyItem: TSocksChainItem;
begin
     for i:=0 to lvProxy.Items.Count - 1 do
     begin
          Item := lvProxy.Items[i];
          if (Item.Selected) then
          begin
               ProxyItem := sockschains.items[i];
               Item.SubItems[3] := 'In progress...';
               ProxyItem.Check;
          end;
     end;
end;

procedure TfrmConfig.CheckHandler(Sender: TObject);
var
   Item: TListItem;
   SocksItem: TSocksChainItem;
begin
     SocksItem := (Sender as TSocksChainItem);
     Item := TListItem(SocksItem.Data);
     Item.SubItems[3] := SocksItem.Status;
end;

procedure TfrmConfig.PingHandler(Sender: TObject);
var
   Item: TListItem;
   SocksItem: TSocksChainItem;
begin
     SocksItem := (Sender as TSocksChainItem);
     Item := TListItem(SocksItem.Data);
     Item.SubItems[2] := IntToStr(SocksItem.PingMSec);;
end;

procedure TfrmConfig.lvProxyColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  (Sender as TCustomListView).AlphaSort;
end;

procedure TfrmConfig.lvProxyCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var
  ix: Integer;
begin
  if ColumnToSort = 0 then
    Compare := CompareText(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompareText(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;

procedure TfrmConfig.lvProxyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key = VK_INSERT then
        btnProxyAddClick(Self);

     if Key = VK_DELETE then
        DeleteProxies();

     if (ssCtrl in Shift) and (Key = VK_UP) then
        MoveProxyUp();
     if (ssCtrl in Shift) and (Key = VK_DOWN) then
        MoveProxyDown();

end;

procedure TfrmConfig.Edit1Click(Sender: TObject);
var
   Item: TSocksChainItem;
   LVItem: TListItem;
begin
     if lvProxy.Selected <> nil then
     begin
          LVItem := lvProxy.Selected;
          Item := GetProxy(LVItem.Index);
          frmNewProxy.ProxyItem := Item;
          if frmNewProxy.ShowModal() = mrOK then
          begin
               GetProxy(LVItem.Index).Assign(frmNewProxy.ProxyItem);
               LVItem.Caption := Item.Server  + ':' + IntToStr(Item.Port);
               LVItem.SubItems[0] := Item.Protocol;
               LVItem.SubItems[1] := Item.Anon;
          end;
     end;
end;

procedure TfrmConfig.TerminateCheck();
var
   Item: TSocksChainItem;
   i: integer;
begin
     for i:=0 to lvProxy.Items.Count - 1 do
     begin
          Item := GetProxy(i);
          Item.Suspend;
     end;
end;


procedure TfrmConfig.MoveProxy(ItemF, ItemT: Word);
var
   Caption: string;
   Checked: Boolean;
   SubItems: TStringList;
begin
     Caption := lvProxy.Items[ItemF].Caption;
     Checked := lvProxy.Items[ItemF].Checked;
     SubItems := TStringList.Create;
     SubItems.Assign(lvProxy.Items[ItemF].SubItems);

     lvProxy.Items[ItemF].Caption := lvProxy.Items[ItemT].Caption;
     lvProxy.Items[ItemF].Checked := lvProxy.Items[ItemT].Checked;
     lvProxy.Items[ItemF].SubItems := lvProxy.Items[ItemT].SubItems;

     lvProxy.Items[ItemT].Caption := Caption;
     lvProxy.Items[ItemT].Checked := Checked;
     lvProxy.Items[ItemT].SubItems := SubItems;

     SubItems.Free;
end;


procedure TfrmConfig.MoveProxyUp();
var
   from_idx, to_idx: integer;
begin
     if (lvProxy.Selected <> nil) then
     begin
          from_idx := lvProxy.Selected.Index;

          lvProxy.Selected := nil;

          to_idx := from_idx - 1;
          if to_idx < 0 then
             to_idx := 0;

          MoveProxy(from_idx, to_idx);
          SocksChains.Exchange(from_idx, to_idx);
          lvProxy.Selected := lvProxy.Items[to_idx];
     end;
end;

procedure TfrmConfig.MoveProxyDown();
var
   from_idx, to_idx: integer;
begin
     if (lvProxy.Selected <> nil) then
     begin
          from_idx := lvProxy.Selected.Index;

          lvProxy.Selected := nil;

          to_idx := from_idx + 1;
          if to_idx > lvProxy.Items.Count - 1 then
             to_idx := lvProxy.Items.Count - 1;

          MoveProxy(from_idx, to_idx);
          SocksChains.Exchange(from_idx, to_idx);
          lvProxy.Selected := lvProxy.Items[to_idx];
     end;
end;

procedure TfrmConfig.DeleteProxies();
var
   i: integer;
   Item: TSocksChainItem;
begin
     for i := lvProxy.Items.Count - 1 downto 0 do
     begin
          if (lvProxy.Items[i].Selected) then
          begin
               Item := GetProxy(i);
               Item.Suspend;
               SocksChains.DelSocks(i);
               lvProxy.Items[i].Delete;
          end;
     end;

     if SocksChains.GetFirstIndex >= 0 then
         DefaultItem := GetProxy(SocksChains.GetFirstIndex)
     else
         DefaultItem := nil;

end;


procedure TfrmConfig.Moveup1Click(Sender: TObject);
begin
     MoveProxyUp();
end;

procedure TfrmConfig.Movedown1Click(Sender: TObject);
begin
     MoveProxyDown();
end;

procedure TfrmConfig.Radio1Click(Sender: TObject);
begin
     SetSocksVer(4);
end;

procedure TfrmConfig.Radio2Click(Sender: TObject);
begin
     SetSocksVer(5);
end;

procedure TfrmConfig.Radio3Click(Sender: TObject);
begin
     SetSocksVer(1);
end;

procedure TfrmConfig.checkAuthClick(Sender: TObject);
begin
     SetSocks5Auth(checkAuth.Checked);
end;

procedure TfrmConfig.checkHttpAuthClick(Sender: TObject);
begin
     SetHttpAuth(checkHttpAuth.Checked);
end;

procedure TfrmConfig.tabDefaultShow(Sender: TObject);
begin
     if SocksChains.GetFirstIndex >= 0 then
     begin
          DefaultItem := SocksChains.Items[SocksChains.GetFirstIndex];
          editSocksServ.Text := DefaultItem.Server;
          editSocksPort.Text := IntToStr(DefaultItem.Port);
          editLogin.Text := DefaultItem.Login;
          editPass.Text := DefaultItem.Password;
          editUserId.Text := DefaultItem.ident;
          checkAuth.Checked := DefaultItem.Auth;
          editHttpUser.Text := DefaultItem.HTTP_User;
          editHttpPass.Text := DefaultItem.HTTP_Pass;
          checkHttpAuth.Checked  := DefaultItem.HTTP_Auth;
          SetSocksVer(DefaultItem.Version);
     end
     else
     begin
          editSocksServ.Text := '';
          editSocksPort.Text := '1080';
          editLogin.Text := '';
          editPass.Text := '';
          editUserId.Text := '';
          checkAuth.Checked := False;
          editHttpUser.Text := '';
          editHttpPass.Text := '';
          checkHttpAuth.Checked  := False;
          SetSocksVer(5);
     end;
     SetHttpAuth(checkHttpAuth.Checked);
     SetSocks5Auth(checkAuth.Checked);
end;

procedure TfrmConfig.btnProxyDelClick(Sender: TObject);
begin
     DeleteProxies;
end;

procedure TfrmConfig.tabPluginsShow(Sender: TObject);
var
   i: integer;
begin
     for i := 0 to lstPlugins.Items.Count - 1 do
        TPluginObject(lstPlugins.Items.Objects[i]).Free;
     lstPlugins.Items.Clear;
end;

procedure TfrmConfig.Button2Click(Sender: TObject);
var
   s: string;
begin
     s := InputBox('New port', 'Enter new port value', '');
     if (s <> '') then
     begin
          if (not IsCorrectPort(s)) then
          begin
               ShowMessage('Invalid port');
               exit;
          end;
          DirectAddr.Add(StrToInt(s));
          lstDirectPorts.Items.Add(s);
     end;
end;

procedure TfrmConfig.Button3Click(Sender: TObject);
var
   i: integer;
begin
     if lstDirectPorts.ItemIndex <> -1 then
     begin
          i := lstDirectPorts.ItemIndex;
          DirectAddr.Del(StrToInt(lstDirectPorts.Items[i]));
          lstDirectPorts.Items.Delete(i);

          if i >= lstDirectPorts.Items.Count then
            lstDirectPorts.ItemIndex := lstDirectPorts.Items.Count - 1
          else
            lstDirectPorts.ItemIndex := i;
     end;
end;

end.
